'Compilable Example:
#Compile Exe  "gbmaze.exe"
#Dim All
#Debug Error On     'catch array/pointer errors - OFF in production
#Debug Display On   'display untrapped errors   - OFF in production

%Unicode = 1
#Include "Win32api.inc"

#Resource Icon logo, "images\gbmaze.ico"
#Resource Icon xnew, "images\new.ico"
#Resource Icon xcopy, "images\copy.ico"
#Resource Icon xxprint, "images\print.ico"
#Resource Icon xsettings, "images\settings.ico"
#Resource Icon xhelp, "images\help.ico"
#Resource Icon xlock, "images\lock.ico"

$Ver = "1.10"
$SessionImage = "session.bmp"

Type CustomColors
   c(15) As Long
End Type

Enum Equates Singular
   IDC_Toolbar
   IDC_Graphic
   IDT_New
   IDT_Copy
   IDT_LockSize
   IDT_Print
   IDT_Settings
   IDT_Help
   IDM_BGColor
   IDM_WallColor
   IDM_LockSize
   IDM_DefaultColors
   IDM_WallSize
   IDM_Sep
End Enum

Global hDlg,hToolbar,hFont,hGraphic,hSettings As Dword
Global cDir() As Point      ' stores the directions that corridors go in
Global blnMaze() As Long, CustomColorList As CustomColors
Global StartColor, StopColor, MazeX, MazeY, LockSize, WallSize, WallColor, BGColor As Long

Function PBMain() As Long
   Dialog New Pixels, 0, "gbMaze   v" + $ver,300,300,400,400, %WS_OverlappedWindow To hDlg
   CreateToolbar
   Control Add Graphic, hDlg, %IDC_Graphic,"Push", 0,60,100,100
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local PTT As TooltipText Ptr, NMTB As TBNotify Ptr, rc As Rect
   Local iResult As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         Settings_INI "get"
         BuildAcceleratorTable
         Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_LockSize, %TBState_Checked * LockSize Or %TBState_Enabled
         ReDim blnMaze(MazeX,MazeY) As Long
         ReDim cDir(3)
         Font New "Tahoma",10,0 To hFont
         Control Set Font hDlg, %IDC_Toolbar, hFont
         Control Handle hDlg, %IDC_Graphic To hGraphic
         Graphic Attach hDlg, %IDC_Graphic, ReDraw
         Graphic Clear
      Case %WM_Size
         ReSizeWindow
      Case %WM_Destroy
         'Graphic Save $SessionImage   'large file, decided not to save
         Settings_INI "save"
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_LockSize
               LockSize Xor= 1
            Case %IDT_Copy
               CopyMaze
            Case %IDT_Print
               SendToPrinter
            Case %IDT_New
               If LockSize = 0 Then GenerateMaze : DrawMaze
            Case %IDT_Settings
               Swap BGColor, WallColor
               DrawMaze
            Case %IDT_Help
               iResult = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbmaze.htm", $Nul, $Nul, %SW_ShowNormal)
            Case %IDM_BGColor
               BGColor = SelectColor(BGColor)
               DrawMaze
            Case %IDM_WallColor
               WallColor = SelectColor(WallColor)
               DrawMaze
            Case %IDM_LockSize
               LockSize Xor= 1
               Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_LockSize, %TBState_Checked * LockSize Or %TBState_Enabled
               DrawMaze
            Case %IDM_DefaultColors
               WallColor = %Blue : BGColor = %Yellow
               DrawMaze
            Case %IDM_WallSize
               WallSize += 1
               If WallSize > 40 Then WallSize = 5
               ResizeWindow
               DrawMaze
         End Select
      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDT_New To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                     PTT = Cb.LParam
                     Select Case Cb.NmId
                        Case %IDT_New      : @PTT.@lpszText = "Create New Maze"
                        Case %IDT_Copy     : @PTT.@lpszText = "Copy Maze Image to Clipboard"
                        Case %IDT_Print    : @PTT.@lpszText = "Print Maze"
                        Case %IDT_LockSize : @PTT.@lpszText = "Lock Maze (No Changes Allowed)"
                        Case %IDT_Settings : @PTT.@lpszText = "Settings"
                        Case %IDT_Help     : @PTT.@lpszText = "Open Online Help Page"
                     End Select
               End Select
            Case %IDC_Toolbar
               Select Case Cb.NmCode
                  Case %TBN_DROPDOWN
                     nmtb = Cb.LParam
                     Select Case @nmtb.iItem
                        Case %IDT_Settings
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           Call TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                     End Select
               End Select
         End Select
   End Select
End Function

Sub CreateToolbar
    Local hImageList As Dword
    ImageList New Icon 24,24,24,50 To hImageList
    ImageList Add Icon hImageList, "xnew"       '1
    ImageList Add Icon hImageList, "xcopy"      '2
    ImageList Add Icon hImageList, "xxprint"    '3
    ImageList Add Icon hImageList, "xsettings"  '4
    ImageList Add Icon hImageList, "xhelp"      '5
    ImageList Add Icon hImageList, "xlock"      '6

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0

    Toolbar Add Button    hDlg, %IDC_Toolbar, 1,  %IDT_New, %BTNS_Button, "New"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_Copy,  %BTNS_Button, "Copy"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_Print,  %BTNS_Button, "Print"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_LockSize,  %BTNS_Check, "Lock"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Settings,  %BTNS_Button Or %BTNS_DropDown, "Settings"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_Help,  %BTNS_Button, "Help"

    Menu New PopUp To hSettings
    Menu Add String, hSettings, "Background Color", %IDM_BGColor, %MF_Enabled
    Menu Add String, hSettings, "Wall Color", %IDM_WallColor, %MF_Enabled
    Menu Add String, hSettings, "Default Colors", %IDM_DefaultColors, %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hSettings, "Increase Border Size" + $Tab + "Ctrl-W", %IDM_WallSize, %MF_Enabled

End Sub

Sub Settings_INI(Task$)
   Local x,y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "490", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "350", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
'      Getprivateprofilestring "All", "FileName", "", FileName, %Max_Path, INIFileName
      'get value for numeric variables
      Getprivateprofilestring "All", "LockSize", "0", temp, %Max_Path, INIFileName:  LockSize = Val(temp)
      Getprivateprofilestring "All", "WallSize", "10", temp, %Max_Path, INIFileName:  WallSize = Val(temp)
      Getprivateprofilestring "All", "WallColor", Str$(%Blue), temp, %Max_Path, INIFileName:  WallColor = Val(temp)
      Getprivateprofilestring "All", "BGColor", Str$(%Yellow), temp, %Max_Path, INIFileName:  BGColor = Val(temp)
      Getprivateprofilestring "All", "MazeX", "35", temp, %Max_Path, INIFileName:  MazeX = Val(temp)
      Getprivateprofilestring "All", "MazeY", "35", temp, %Max_Path, INIFileName:  MazeY = Val(temp)
      Getprivateprofilestring "All", "StartColor", Str$(%Green), temp, %Max_Path, INIFileName:  StartColor = Val(temp)
      Getprivateprofilestring "All", "StopCOlor", Str$(%Red), temp, %Max_Path, INIFileName:  StopColor = Val(temp)
      For x = 0 To 15
         Getprivateprofilestring "All", "CustomColorC" + Format$(x,"00"), "", temp, %Max_Path, INIFileName
         CustomColorList.c(x) = Val(temp)
      Next x

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
'      WritePrivateProfileString "All", "FileName",FileName, INIFileName
      'save numeric variables
      WritePrivateProfileString "All", "LockSize", Str$(LockSize), INIFileName
      WritePrivateProfileString "All", "WallSize", Str$(WallSize), INIFileName
      WritePrivateProfileString "All", "WallColor", Str$(WallColor), INIFileName
      WritePrivateProfileString "All", "BGColor", Str$(BGColor), INIFileName
      WritePrivateProfileString "All", "MazeX", Str$(MazeX), INIFileName
      WritePrivateProfileString "All", "MazeY", Str$(MazeY), INIFileName
      WritePrivateProfileString "All", "StartColor", Str$(StartColor), INIFileName
      WritePrivateProfileString "All", "StopColor", Str$(StopColor), INIFileName
      For x = 0 To 15
         temp = Str$(CustomColorList.c(x))
         WritePrivateProfileString "All", "CustomColorC" + Format$(x,"00"), temp, INIFileName
      Next x
   End If
End Sub


Sub GenerateMaze()
    Local cN, cS As Point, intDir, intDone, blnBlocked As Long
    MazeX = Max(3,MazeX) : MazeY = Max(3,MazeY)
    Randomize Timer : Reset blnMaze()
    Do
        cS.X = 2 + (Int(((MazeX - 1) * Rnd) / 2) * 2)    ' this code is used to make sure the numbers are odd
        cS.Y = 2 + (Int(((MazeY - 1) * Rnd) / 2) * 2)    ' this code is used to make sure the numbers are odd
        If intDone = 0 Then blnMaze(cS.X, cS.Y) = %True  ' first one is free!
        If blnMaze(cS.X, cS.Y) Then
            RandomDirections                 ' always randomisation directions to start
            Do
                RandomDirections
                blnBlocked = %True           ' loop through order of directions
                For intDir = 0 To 3
                    ' work out where this direction is
                    cN.X = cS.X + (cDir(intDir).X * 2)
                    cN.Y = cS.Y + (cDir(intDir).Y * 2)
                    ' check if the tile can be used
                    If IsFree(cN) Then
                        blnMaze(cN.X, cN.Y) = %True    ' create a path
                        blnMaze(cS.X + cDir(intDir).X, cS.Y + cDir(intDir).Y) = %True   ' and the square inbetween
                        cS.X = cN.X : cS.Y = cN.Y      ' this is now the current square
                        blnBlocked = %False
                        intDone = intDone + 1          ' increment paths created
                        Exit For
                    End If
                Next
            Loop Until blnBlocked   ' loop until a path was created
        End If
    Loop While intDone + 1 < ((MazeX - 1) * (MazeY - 1)) / 4   ' create enough paths to fill the whole grid
End Sub

Sub RandomDirections()        ' this changes the direction to go from the current square, to the next available
    Reset cDir()              ' clear the array
    Select Case Int(3 * Rnd)  ' four possible sets of directions
        Case 0 : cDir(0).X = -1: cDir(1).X = 1 : cDir(2).Y = -1: cDir(3).Y = 1
        Case 1 : cDir(3).X = -1: cDir(2).X = 1 : cDir(1).Y = -1: cDir(0).Y = 1
        Case 2 : cDir(2).X = -1: cDir(3).X = 1 : cDir(0).Y = -1: cDir(1).Y = 1
        Case 3 : cDir(1).X = -1: cDir(0).X = 1 : cDir(3).Y = -1: cDir(2).Y = 1
    End Select
End Sub

Function IsFree(cF As Point) As Long                                 ' checks if a tile is free for use
    If cF.X < MazeX And cF.X > 1 And cF.Y < MazeY And cF.Y > 1 Then  ' check it's within the grid
        IsFree = (blnMaze(cF.X, cF.Y) = %False)                      ' check it hasn't been used yet
    End If
End Function

Sub DrawMaze
    Local x,y As Long
    Graphic Clear
    For y = 1 To MazeY : For x = 1 To MazeX
      If (x=2) And (y=1) Then Iterate For
      If (x=MazeX-1) And (y=MazeY) Then Iterate For
      If IsFalse(blnMaze(x,y)) Then
         Graphic Box (x*WallSize,y*WallSize)-(x*WallSize+WallSize,y*WallSize+WallSize),,WallColor,WallColor
      Else
         Graphic Box (x*WallSize,y*WallSize)-(x*WallSize+WallSize,y*WallSize+WallSize),,BGColor,BGColor
      End If
    Next : Next
    Graphic Box (2*WallSize,1*WallSize)-(2*WallSize+WallSize,1*WallSize+WallSize),,StartColor,StartColor
    Graphic Box ((MazeX-1)*WallSize,MazeY*WallSize)-((MazeX-1)*WallSize+WallSize,MazeY*WallSize+WallSize),,StopColor,StopColor
    Graphic ReDraw
    Dialog Set Text hDlg, "gbMaze   v" + $ver + "            Border Size: " + Str$(WallSize)
End Sub

Sub SendToPrinter
   Local wImg, hImg, wNew, hNew, x,y, wCont, hCont As Long
   On Error GoTo ExitPrint
   XPrint Attach Choose
   Control Get Client hDlg, %IDC_Graphic To wImg, hImg
   XPrint Get Client To wCont, hCont
   wNew = wImg / Max(wImg / wCont, hImg / hCont)
   hNew = hImg / Max(wImg / wCont, hImg / hCont)
   x = (wCont-wNew)/2
   y = (hCont-hNew)/2 'upper/left position so resized image is centered
   XPrint Stretch hDlg, %IDC_Graphic, (0,0)-(wImg-1,hImg-1) To (x,y)-(x+wNew-1,y+hNew-1)  'copy (resized) from memory bitmap to visible image

   Font New "Tahoma",12,1 To hFont
   XPrint Set Font hFont
   XPrint Set Pos (100,100)
   XPrint "gbMaze   v" + $ver + "        " + Date$ + "  " + Time$

   XPrint Close
   Font End hFont
ExitPrint:
End Sub

Sub ResizeWindow
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   Graphic Set Client, w,h-60
   w -= 2*WallSize : h-= (60 + 2*WallSize)
   If LockSize = 0 Then
      MazeX = w / WallSize
      MazeY = h / WallSize
      If MazeX Mod 2 = 0 Then Decr MazeX
      If MazeY Mod 2 = 0 Then Decr MazeY
      MazeX = Max(3,MazeX)
      MazeY = Max(3,MazeY)
      ReDim blnMaze(MazeX,MazeY)
      GenerateMaze
      DrawMaze
   End If
End Sub

Function SelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(5)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd   = %IDT_Help       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N  : ac(c).cmd   = %IDT_New        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_C  : ac(c).cmd   = %IDT_Copy       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_P  : ac(c).cmd   = %IDT_Print      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_L  : ac(c).cmd   = %IDM_LockSize   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_W  : ac(c).cmd   = %IDM_WallSize   : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub CopyMaze
   Local hBmp As Dword, x0,y0,x1,y1 As Long
   x0 = WallSize
   y0 = WallSize
   x1 = MazeX * WallSize + WallSize
   y1 = MazeY * WallSize + WallSize
   Graphic Bitmap New (x1-x0), (y1-y0) To hBMP
   Graphic Attach hBMP, 0
   Graphic Copy hDlg, %IDC_Graphic, (x0,y0)-(x1,y1) To (0,0)
   Clipboard Reset
   Clipboard Set Bitmap hBMP
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
End Sub
